#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int N;
    cin >> N;
    
    vector<int> A(N), B(N);
    for (int i = 0; i < N; i++) {
        cin >> A[i];
    }
    for (int i = 0; i < N; i++) {
        cin >> B[i];
    }

    int maxValue = 0;
    
    // O(n^2)
    for (int L = 0; L < N; L++) {
        int xorValue = 0; 
        int andValue = -1; 
        
        for (int R = L; R < N; R++) {
            xorValue ^= A[R];  
            andValue &= B[R];  
            
            maxValue = max(maxValue, xorValue * andValue);
        }       
    }

    cout << maxValue << endl;
    return 0;
}